<?php

/**
 * inf_titulo_ejec actions.
 *
 * @package    CobroCoactivo
 * @subpackage inf_titulo_ejec
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_titulo_ejecActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' order by tab0.id_anhos ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //Codigo Titulo
            if (isset($request['cod_titulo'])) {
                $whereCodTitulo = " AND tab0.cod_titulo = " . $request['cod_titulo'];
            } else {
                $whereCodTitulo = ' ';
            }
            //id_contrato
         /*   if (isset($request['id_contrato'])) {
                $whereIdContrato = " AND tab0.id_contrato = " . $request['id_contrato'];
            } else {
                $whereIdContrato = ' ';
            }*/
            //id anhos
            if(isset($request['id_anhos'])){
                $whereAnho = 'AND tab0.id_anhos = '.$request['id_anhos'];
            } else {
                $whereAnho = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             *
             */
            $consulta_sql = <<<EOD
select
tab0.*
from(
                    
   select
  to_char(tab0.fecha_remision,'dd/mm/yyyy') as fecha_remision,
  tab0.cod_titulo,
  to_char(tab2.fecha, 'dd/mm/yyyy') as fecha_aprueba_rpto,
  tab2.aprobado as aprobado_rpto,
  tab5.num_doc || ' ' || tab5.razon_soc as doc_abogado,
  cac.no_auto as no_auto_avoca,
  to_char(cac.fecha) as fecha_avoca,
  cac.observaciones as observ_avoca,
  cac.adjunto as adjunto_avoca,
  cp.descripcion as desc_plantilla_avoca,
  ctd.descripcion as desc_tipo_doc_avoca,
  to_char(tab6.fecha_cierre) as fecha_cierre_persua,
  tab6.estado as estado_cierre_persua,
  tab6.adjunto as adjunto_cierre_persua,
  tab6.observaciones as observ_cierre_persua,
  tab7.no_auto as no_auto_cierre,
  to_char(tab7.fecha) as fecha_auto_cierre,
  cpc.ID_PROCESO_COACTIVO,
  cpc.NO_PROCESO,
  cpc.ID_ANHOS,
  cpc.FECHA as fecha_cobro_coactivo,--HASTA AQUI CAMPOS TABLA CBR_PROCESO_COACTIVO
  cad.fecha as fecha_aprob_deneg,
  cad.aprobado as aprobado_deneg,
  cod.no_oficio,
  cei.descripcion as entidad_investiga,
  cfp.fecha_registro	as fecha_facilidad_pago,
  ca.fecha as fecha_avaluo
  from cbr_remision_titulo tab0
  left join cbr_avoca_conoc cac on cac.id_remision_titulo = tab0.id_remision_titulo
  left join CBR_PROCESO_COACTIVO cpc on cpc.ID_REMISION_TITULO=tab0.ID_REMISION_TITULO
  left join cbr_facilidad_pago cfp on cfp.id_proceso_coactivo=cpc.id_proceso_coactivo

 left join cbr_secuestro cs on cs.id_remision_titulo=cpc.id_remision_titulo

 left join cbr_avaluo ca on ca.id_secuestro=cs.id_secuestro
left join cbr_aprob_deneg cad on cad.ID_REMISION_TITULO=tab0.ID_REMISION_TITULO
left join cbr_oficio_deudor cod on cod.id_remision_titulo = cac.id_remision_titulo
left join cbr_investiga_bienes cib on cib.id_remision_titulo = cod.id_remision_titulo
left join cbr_entidad_ib cei on cei.id_entidad_ib = cib.id_entidad_ib
left join cbr_plantilla cp on cp.id_plantilla = cac.id_plantilla
left join cbr_tipo_documento ctd on ctd.id_tipo_documento = cac.id_tipo_documento
left join cbr_par tab1 on tab1.id_par = tab0.id_par
left join cbr_aprueba_reparto tab2 on tab2.id_remision_titulo = tab0.id_remision_titulo
left join cbr_reparto tab3 on tab3.id_remision_titulo = tab2.id_remision_titulo
left join cbr_abogado tab4 on tab4.id_abogado = tab3.id_abogado
left join interceros tab5 on tab5.id_mae_ter = tab4.id_mae_ter
left join cbr_cierre_persuasivo tab6 on tab6.id_remision_titulo = tab0.id_remision_titulo
left join cbr_auto_cierre tab7 on tab7.id_remision_titulo = tab6.id_remision_titulo

where tab0.fecha_remision between to_date( '$fecha_ini', 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )



)tab0
                    
where
1 = 1 
$whereCodTitulo
$whereAnho                    
     
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_titulo_ejec] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
